- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# FUObject Class Reference
[Utility Classes.]

A basic object. More...

`#include <FUObject.h>`

Inheritance diagram for FUObject:

List of all members.

## Public Member Functions
| FUObject ()
| Constructor.
virtual | ~FUObject ()
| Destructor.
virtual void | Release ()
| Releases this object.
virtual const FUObjectType & | GetObjectType () const
| Retrieves the type of the object class.
bool | IsType (const FUObjectType &_type) const
| Retrieves whether this object has exactly the given type.
bool | HasType (const FUObjectType &_type) const
| Retrieves whether this object is exactly or inherits the given type.
## Static Public Member Functions
static const FUObjectType & | GetClassType ()
| Retrieves the type of the base object class.
## Protected Member Functions
void | Detach ()
| Detaches this object from its owner.
## Static Protected Attributes
static const uint32 | nextAvailableBit = 0
| [INTERNAL] Necessary, in order for the flag macros to work on up-classes.
## Friends
class | FUObjectOwner

## Detailed Description

A basic object.

Each up-class of this basic object class hold an object type that acts just like RTTI to provide a safe way to up-cast.

## Constructor & Destructor Documentation

FUObject::FUObject | ( |  | ) |

| Constructor. Although it is not an abstract class, this class is not meant to be used directly.

## Member Function Documentation

void FUObject::Detach | ( |  | ) | `[protected]`

| Detaches this object from its owner. Mainly notifies the owner before the destructor is called. Reimplemented in FUTrackable.

static const FUObjectType& FUObject::GetClassType | ( |  | ) | `[inline, static]`

| Retrieves the type of the base object class. Returns: The type of the base object class.

virtual const FUObjectType& FUObject::GetObjectType | ( |  | ) | const`[inline, virtual]`

| Retrieves the type of the object class. Returns: The type of the base object class.

bool FUObject::HasType | ( | const FUObjectType & | _type | ) | const`[inline]`

  | Retrieves whether this object is exactly or inherits the given type. Parameters:
  | _type | A given class type.
Returns: Whether this object is exactly or inherits the given type.

bool FUObject::IsType | ( | const FUObjectType & | _type | ) | const`[inline]`

  | Retrieves whether this object has exactly the given type. Parameters:
  | _type | A given class type.
Returns: Whether this object is exactly of the given type.

virtual void FUObject::Release | ( |  | ) | `[virtual]`

| Releases this object. This function essentially calls the destructor. This function is virtual and is always overwritten when using the ImplementObjectType macro.

The documentation for this class was generated from the following file:

- FUtils/FUObject.h